Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.persistence
Annotation Type ManyToOne

    @Target(value={METHOD,FIELD})
    @Retention(value=RUNTIME)
    public @interface ManyToOne

Defines a single-valued association to another entity class that has many-to-one multiplicity. It is not normally necessary to specify the target entity explicitly since it can usually be inferred from the type of the object being referenced. If the relationship is bidirectional, the non-owning `OneToMany` entity side must used the `mappedBy` element to specify the relationship field or property of the entity that is the owner of the relationship.

The `ManyToOne` annotation may be used within an embeddable class to specify a relationship from the embeddable class to an entity class. If the relationship is bidirectional, the non-owning `OneToMany` entity side must use the `mappedBy` element of the `OneToMany` annotation to specify the relationship field or property of the embeddable field or property on the owning side of the relationship. The dot (".") notation syntax must be used in the `mappedBy` element to indicate the relationship attribute within the embedded attribute. The value of each identifier used with the dot notation is the name of the respective embedded field or property.

         Example 1:

         @ManyToOne(optional=false)
         @JoinColumn(name="CUST_ID", nullable=false, updatable=false)
         public Customer getCustomer() { return customer; }

         Example 2:

         @Entity
            public class Employee {
            @Id int id;
            @Embedded JobInfo jobInfo;
            ...
         }

         @Embeddable
            public class JobInfo {
            String jobDescription;
            @ManyToOne ProgramManager pm; // Bidirectional
         }

         @Entity
            public class ProgramManager {
            @Id int id;
            @OneToMany(mappedBy="jobInfo.pm")
            Collection<Employee> manages;
         }

Since:
  Java Persistence 1.0

Optional Element Summary
`CascadeType[]` | `cascade` (Optional) The operations that must be cascaded to the target of the association.
`FetchType` | `fetch` (Optional) Whether the association should be lazily loaded or must be eagerly fetched.
`boolean` | `optional` (Optional) Whether the association is optional.
`java.lang.Class` | `targetEntity` (Optional) The entity class that is the target of the association.

### targetEntity

    public abstract java.lang.Class targetEntity

  (Optional) The entity class that is the target of the association.

  Defaults to the type of the field or property that stores the association.

  Default:
    void.class

### cascade

    public abstract CascadeType[] cascade

  (Optional) The operations that must be cascaded to the target of the association.

  By default no operations are cascaded.

  Default:
    {}

### fetch

    public abstract FetchType fetch

  (Optional) Whether the association should be lazily loaded or must be eagerly fetched. The EAGER strategy is a requirement on the persistence provider runtime that the associated entity must be eagerly fetched. The LAZY strategy is a hint to the persistence provider runtime.

  Default:
    javax.persistence.FetchType.EAGER

### optional

    public abstract boolean optional

  (Optional) Whether the association is optional. If set to false then a non-null relationship must always exist.

  Default:
    true

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT